/**
 * Objekt pro jeden call
 * @author Miroslav Hendrych
 */
public class CallParams {
    private int param;
    private int result;
    private boolean resultReady = false;

    public CallParams(Integer param) {
        this.param = param;
    }

    public int getParam() {
        return param;
    }

    public synchronized void setResult(int result) {
        this.result = result;
        this.resultReady = true;
        this.notify();
    }

    public synchronized int getResult() {
        while (!resultReady)
            try {
                this.wait();
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        return result;
    }

}
