
import java.util.LinkedList;
import java.util.Random;

/**
 * Testovací rendez-vous program1 - hlavní třída
 * @author Miroslav Hendrych
 */
public class Main {
    private LinkedList<CallParams> calls = new LinkedList<CallParams>();
    private Random random;

    public static int COUNT = 400;
    public static int MAX_WAIT = 100;

    public int getRandomInterval() {
        return random.nextInt(MAX_WAIT)+1;
    }

    public void sleep() {
        try {
            Thread.sleep(getRandomInterval());
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
    }

    public CallParams accept() {
        synchronized (calls) {
            while (calls.isEmpty())
                try {
                    calls.wait();
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }
            return calls.removeFirst();
        }
    }

    public int call(int param) {
        CallParams cp = new CallParams(param);
        synchronized (calls) {
            calls.add(cp);
            calls.notify();
        }
        sleep();  // nahodna doba zdrzeni
        return cp.getResult();
    }

    public Main() {
        random = new Random();
        Klient klient = new Klient(this);
        Server server = new Server(this);

        server.start();
        klient.start();

        try {
            server.join();
            klient.join();
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Main();
    }

}
