

import java.util.Random;
import rendezvous.RendezVous;

/**
 * Klientské vlákno
 * @author Miroslav Hendrych
 */
public class Klient extends Thread {
    private RendezVous rendezvous;
    private int plus = 1000;
    private int minus = 500;
    private int hodnota = 0;
    private int predpokladanaHodnota;


    public Klient(RendezVous rendezvous) {
        this.rendezvous = rendezvous;
        predpokladanaHodnota = plus-minus;
    }

    @Override
    public void run() {
        Long[] plusID = rendezvous.getServersByEntryName("plus");
        Long[] minusID = rendezvous.getServersByEntryName("minus");
        Random rnd = new Random();
        for (; plus>0 || minus>0 ;) {
            boolean operacePlus;
            if (plus>0 && minus>0)
                operacePlus = rnd.nextBoolean();
            else
                operacePlus = plus > 0;
            if (operacePlus) {
                long server = plusID[rnd.nextInt(plusID.length)];
                hodnota = (Integer)rendezvous.call(server, "plus", hodnota);
                plus--;
            } else {
                long server = minusID[rnd.nextInt(minusID.length)];
                hodnota = (Integer)rendezvous.call(server, "minus", hodnota);
                minus--;
            }
        }
    }

    public boolean isCorrect() {
        return hodnota == predpokladanaHodnota;
    }


}
