import rendezvous.RendezVous;


/**
 * Testovací rendez-vous program2 - hlavní třída
 * @author Miroslav Hendrych
 */
public class Main {
    public static String entryName = "ready";
    public static int defPocetServeru = 5;
    public static int defPocetKlientu = 13;

    private static void provedSimulaci(RendezVous rendezvous, int pocetServeru,  int pocetKlientu) {
        Server[] servery = new Server[pocetServeru];
        Klient[] klienti = new Klient[pocetKlientu];

        for (int i=0; i<pocetServeru; i++) {
            servery[i] = new Server(i+1, rendezvous);
            servery[i].start();
        }
        for (int i=0; i<pocetKlientu; i++) {
            klienti[i] = new Klient(rendezvous);
            klienti[i].start();
        }
        for (int i=0; i<pocetKlientu; i++) {
            try {
                klienti[i].join();
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            System.out.println("Klient "+(i+1)+":  spravny vysledek = "+klienti[i].isCorrect());
        }

        for (int i=0; i<pocetServeru; i++)
            rendezvous.call(servery[i].getId(), "stop", i+1);
        for (int i=0; i<pocetServeru; i++)
            try {
                servery[i].join();
                servery[i].printStats();
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }

    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        RendezVous rendezvous = new RendezVous();
        if (args.length==0) {
            System.out.println("V parametrech lze v tomto poradi specifikovat pocet serveru a pocet klientu");
            provedSimulaci(rendezvous, defPocetServeru, defPocetKlientu);
        } else {
            if (args.length == 2) {
                int serveru = Integer.parseInt(args[0]);
                int klientu = Integer.parseInt(args[1]);
                provedSimulaci(rendezvous, serveru, klientu);
            } else {
                System.out.println("Chybny pocet parametru");
                System.out.println("Zadej parametry v tomto poradi: pocet serveru a pocet klientu");
            }
        }
    }

}