package rendezvous;

/**
 * Třída pro jeden call
 * @author Miroslav Hendrych
 */
public class EntryCall {
    private boolean resultReady = false;
    private Object result = null;
    private long serverID;
    private String entryName;
    private Object params;

    @Override
    public String toString() {
        return "volani "+serverID+"."+entryName+"("+params+")";
    }

    public EntryCall(long serverID, String entryName, Object params) {
        this.serverID = serverID;
        this.entryName = entryName;
        this.params = params;
    }

    public String getEntryName() {
        return entryName;
    }

    public Object getParams() {
        return params;
    }

    public long getServerID() {
        return serverID;
    }

    public synchronized void setResult(Object result) {
        this.result = result;
        resultReady = true;
        this.notify();
    }

    public synchronized Object getResult() {
        while (!resultReady)
            try {
                wait();
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        return result;
    }
}
