

import java.util.Random;
import rendezvous.RendezVous;

/**
 * Rendez-vous klient
 * @author Miroslav Hendrych
 */
public class Klient extends Thread {
    private RendezVous rendezvous;
    private String entry;
    private long server;
    private boolean chyba = false;


    public Klient(RendezVous rendezvous, long server, boolean operacePlus) {
        this.rendezvous = rendezvous;
        this.server = server;
        this.entry = operacePlus ? "plus" : "minus";
    }

    @Override
    public void run() {
        Random rnd = new Random();
        for (int i=0; i<20 ; i++) {
            if (rendezvous.call(server, entry, this.getId()) == null) {
                chyba = true;
                return;
            }
            Object hodnota = rendezvous.call(server, "hodnota", this.getId());
            if (hodnota == null) {
                chyba = true;
                return;
            }
            int value = (Integer)hodnota;
            if (value < Main.stred-Main.interval || value > Main.stred+Main.interval) {
                chyba = true;
                return;
            }

            System.out.println(hodnota);

            try {
                Thread.sleep(rnd.nextInt(1000));
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        }
    }

    public boolean isCorrect() {
        return !chyba;
    }

}
