import rendezvous.IEntry;
import rendezvous.RendezVous;
/**
 * Testovací rendez-vous program3 - hlavní třída
 * @author Miroslav Hendrych
 */
public class Main {
    public static int pocetKlientu = 50;
    public static int stred = 100;
    public static int interval = 5;

    private static void provedSimulaci(RendezVous rendezvous) {
        Klient[] klienti = new Klient[2*pocetKlientu];

        Server server = new Server(rendezvous);
        server.start();
        long serverID = server.getId();
        boolean spravne = true;

        for (int i=0; i<klienti.length; i++) {
            klienti[i] = new Klient(rendezvous, serverID, i%2==0);
            klienti[i].start();
        }
        for (int i=0; i<klienti.length; i++) {
            try {
                klienti[i].join();
                System.out.println("Klient "+i+" skoncil, spravne = "+klienti[i].isCorrect());
                spravne = spravne && klienti[i].isCorrect();
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        }
        try {
            server.join();
            System.out.println("Server skoncil.");
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        System.out.println("Celkove hodnoceni: spravne = "+spravne);

    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        RendezVous rendezvous = new RendezVous();

        provedSimulaci(rendezvous);
    }

}
class EntryServerReady implements IEntry {
    public Object entry(Object params) {
        return null;
    }
}
